﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Microsoft.Azure.Devices;
using Microsoft.Azure.Devices.Common.Exceptions;
using static System.Console;

namespace BrainComputerInterface_CreateIdentity
{
    class Program
    {
        static RegistryManager _registryManager;
        static string _connectionString = "HostName=****.azure-devices.net;SharedAccessKeyName=iothubowner;SharedAccessKey=***ADD YOURS HERE****";

        static void Main(string[] args)
        {
            _registryManager = RegistryManager.CreateFromConnectionString(_connectionString);
            AddDeviceAsync().Wait();
            ReadLine();
        }

        private static async Task AddDeviceAsync()
        {
            string deviceId = "BrainComputerInterface001";
            Device device;
            try
            {
                device = await _registryManager.AddDeviceAsync(new Device(deviceId));
            }
            catch (DeviceAlreadyExistsException)
            {
                device = await _registryManager.GetDeviceAsync(deviceId);
            }
            WriteLine($"Generated device key: {device.Authentication.SymmetricKey.PrimaryKey}");
        }
    }
}
